searchNodes=[{"doc":"A set of process-less functions for forming A2S challenges, requests, and parsing responses.","ref":"A2S.html","title":"A2S","type":"module"},{"doc":"","ref":"A2S.html#challenge_request/1","title":"A2S.challenge_request/1","type":"function"},{"doc":"Parses a challenge response payload. Some game servers don't implement the challenge flow and will immediately respond with the requested data. In that case :immediate will be returned with the data. If the server returns data immediately, and that data is multipart, :multipart will be returned.","ref":"A2S.html#parse_challenge/1","title":"A2S.parse_challenge/1","type":"function"},{"doc":"","ref":"A2S.html#parse_multipacket_response/1","title":"A2S.parse_multipacket_response/1","type":"function"},{"doc":"","ref":"A2S.html#parse_response/1","title":"A2S.parse_response/1","type":"function"},{"doc":"","ref":"A2S.html#sign_challenge/2","title":"A2S.sign_challenge/2","type":"function"},{"doc":"An easy to use client that performs the handshaking and busy-work necessary to make execute A2S queries. This client handles requests concurrently and should be suitable for most general uses. Note: must supply a :name","ref":"A2S.Client.html","title":"A2S.Client","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"A2S.Client.html#child_spec/1","title":"A2S.Client.child_spec/1","type":"function"},{"doc":"Query a game server running at address for the data specified by query .","ref":"A2S.Client.html#query/3","title":"A2S.Client.query/3","type":"function"},{"doc":"","ref":"A2S.Client.html#start_link/1","title":"A2S.Client.start_link/1","type":"function"},{"doc":"Struct representing an A2S_INFO response.","ref":"A2S.Info.html","title":"A2S.Info","type":"module"},{"doc":"Struct representing a multi-packet response header .","ref":"A2S.MultiPacketHeader.html","title":"A2S.MultiPacketHeader","type":"module"},{"doc":"","ref":"A2S.MultiPacketHeader.html#t:t/0","title":"A2S.MultiPacketHeader.t/0","type":"type"},{"doc":"Struct representing a player entry in an A2S_PLAYER response.","ref":"A2S.Player.html","title":"A2S.Player","type":"module"},{"doc":"","ref":"A2S.Player.html#t:t/0","title":"A2S.Player.t/0","type":"type"},{"doc":"Struct representing an A2S_PLAYER response.","ref":"A2S.Players.html","title":"A2S.Players","type":"module"},{"doc":"","ref":"A2S.Players.html#t:t/0","title":"A2S.Players.t/0","type":"type"},{"doc":"Struct representing a rule in an A2S_RULES response.","ref":"A2S.Rule.html","title":"A2S.Rule","type":"module"},{"doc":"","ref":"A2S.Rule.html#t:t/0","title":"A2S.Rule.t/0","type":"type"},{"doc":"Struct representing an A2S_RULES response.","ref":"A2S.Rules.html","title":"A2S.Rules","type":"module"},{"doc":"","ref":"A2S.Rules.html#t:t/0","title":"A2S.Rules.t/0","type":"type"},{"doc":"A state machine process responsible for handling all A2S queries to a game server running at the given address. Queries must be performed sequentially per address, as A2S provides no way to associate what replies associate to what responses. Each instance should exit normally after a certain interval of inactivity (currently hard-coded to 2 minutes).","ref":"A2S.Statem.html","title":"A2S.Statem","type":"module"},{"doc":"","ref":"A2S.Statem.html#child_spec/1","title":"A2S.Statem.child_spec/1","type":"function"},{"doc":"","ref":"A2S.Statem.html#start_link/1","title":"A2S.Statem.start_link/1","type":"function"},{"doc":"","ref":"A2S.Statem.html#stop/2","title":"A2S.Statem.stop/2","type":"function"},{"doc":"","ref":"A2S.Statem.html#t:init_args/0","title":"A2S.Statem.init_args/0","type":"type"},{"doc":"Singleton dynamic supervisor for A2S.Statem processes.","ref":"A2S.Supervisor.html","title":"A2S.Supervisor","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"A2S.Supervisor.html#child_spec/1","title":"A2S.Supervisor.child_spec/1","type":"function"},{"doc":"Starts an A2S.Statem for the specified address .","ref":"A2S.Supervisor.html#start_child/1","title":"A2S.Supervisor.start_child/1","type":"function"},{"doc":"","ref":"A2S.Supervisor.html#start_link/1","title":"A2S.Supervisor.start_link/1","type":"function"},{"doc":"GenServer wrapper over :gen_udp , responsible for sending packets to game-servers and routing received packets to the appropriate A2S.Statem process.","ref":"A2S.UDP.html","title":"A2S.UDP","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"A2S.UDP.html#child_spec/1","title":"A2S.UDP.child_spec/1","type":"function"},{"doc":"Send the given msg packet to the game server.","ref":"A2S.UDP.html#handle_call/3","title":"A2S.UDP.handle_call/3","type":"function"},{"doc":"Forward received packets to the appropriate A2S.Statem .","ref":"A2S.UDP.html#handle_info/2","title":"A2S.UDP.handle_info/2","type":"function"},{"doc":"","ref":"A2S.UDP.html#start_link/1","title":"A2S.UDP.start_link/1","type":"function"},{"doc":"A library for communicating with game servers running Valve's A2S server query protocol .","ref":"readme.html","title":"A2S","type":"extras"},{"doc":"The package can be installed by adding a2s to your list of dependencies in mix.exs : def deps do [ { :a2s , &quot;~&gt; 0.2.0&quot; } ] end Documentation can be generated with ExDoc and published on HexDocs . Once published, the docs can be found at https://hexdocs.pm/a2s .","ref":"readme.html#installation","title":"A2S - Installation","type":"extras"},{"doc":"There's two general ways to use this library: Via A2S.Client An easy to use client that should cover most use-cases. Add A2S.Client to your app's supervision tree: children = [ {A2S.Client, [name: MyA2SCli]} ] Or start the client dynamically: A2S.Client.start_link([name: MyA2SCli]) Afterwards querying a game server's as simple as: A2S.Client.query(:info, {{127, 0, 0, 1}, 20000}) # ipv4 address followed by port Via A2S This module provides the means form requests, sign challenges, and parse responses for the A2S protocol. You can utilize this module directly in your application for tighter integration, but in turn you'll have to handle the networking or handshaking necessary to execute A2S queries. See the roll your own guide and the internals of A2S.Client may serve as a good reference in that regard.","ref":"readme.html#usage","title":"A2S - Usage","type":"extras"},{"doc":"The features and game servers listed below are unsupported due to disuse and to favor maintainability. Source 2006 / &quot;Pre-Orange Box&quot; servers Would require supporting compression in multipacket responses. Not only adds code complexity, but would require users to have bzip2 installed. Other game servers utilizing multi-packet compression (see above) GoldSrc Servers not using the standard protocol Should impact exceedingly few applications as many GoldSrc servers use the current standard anyway. The Ship Uses proprietary fields only worth supporting out of posterity-sake. A2A_PING Considered deprecated by Valve and is unsupported by many if not almost all most engines. A2S_SERVERQUERY_GETCHALLENGE Only used by a handful of niche games. Normal challenge flow should work anyway.","ref":"readme.html#unsupported-games-and-features","title":"A2S - Unsupported Games and Features","type":"extras"},{"doc":"If you'd like to report an issue, please include as much information as possible to reproduce the issue.","ref":"readme.html#issues","title":"A2S - Issues","type":"extras"},{"doc":"A2S.Client uses Erlang's gen_statem behavior to function and therefore requires the following Logger configuration to report exceptions and crashes: config :logger, handle_otp_reports: true, handle_sasl_reports: true or in a REPL: Logger.configure(handle_otp_reports: true) Logger.configure(handle_sasl_reports: true)","ref":"readme.html#debugging","title":"A2S - Debugging","type":"extras"},{"doc":"Make statem timeouts configurable Fix A2S.Supervisor startup arguments (currently ignored) Fix Registry static name of :a2s_registry Improve hexdocs, review moduledocs, and readme Explain internals of A2S, design motivations for this library, and a roll-your-own guide. Write proper tests Test with significant concurrent usage Add more typespecs (maybe)","ref":"readme.html#much-todo","title":"A2S - (Much) Todo:","type":"extras"}]